From a82fcd8ec6010ff022c2b7422c58559d1262e7dd Mon Sep 17 00:00:00 2001
From: Alexander Brown <drjkl@comfy.org>
Date: Wed, 3 Sep 2025 22:57:53 -0700
Subject: [PATCH 44/77] Knip: Enable more rules (#5309)

* knip: Simplify config

* knip: enable unlisted, fix issues

* knip: Add ignore for build dependencies (Vite plugin indirect reference)

* knip: Prune dependencies

* knip: One more Unused dep

* git: Standard line end for yaml

* [auto-fix] Apply ESLint and Prettier fixes

* knip: Add exceptions for tailwindcss post-rebase.
Not sure why we need to except it.

* Update test expectations [skip ci]

---------

Co-authored-by: GitHub Action <action@github.com>
Co-authored-by: github-actions <github-actions@github.com>
---
 .gitattributes                                |   1 +
 browser_tests/fixtures/UserSelectPage.ts      |   3 +-
 browser_tests/fixtures/utils/taskHistory.ts   |   2 +-
 ...x-multiple-nodes-border-chromium-linux.png | Bin 105738 -> 105796 bytes
 ...tiple-selections-border-chromium-linux.png | Bin 105738 -> 105796 bytes
 ...x-single-node-no-border-chromium-linux.png | Bin 101680 -> 101743 bytes
 ...gle-selection-no-border-chromium-linux.png | Bin 101680 -> 101743 bytes
 knip.config.ts                                |  45 +-
 package.json                                  |  13 +-
 pnpm-lock.yaml                                | 439 ++++++------------
 10 files changed, 167 insertions(+), 336 deletions(-)

diff --git a/.gitattributes b/.gitattributes
index 749554ee1..de05efbf4 100644
--- a/.gitattributes
+++ b/.gitattributes
@@ -9,6 +9,7 @@
 *.mts text eol=lf
 *.ts text eol=lf
 *.vue text eol=lf
+*.yaml text eol=lf
 
 # Generated files
 src/types/comfyRegistryTypes.ts linguist-generated=true
diff --git a/browser_tests/fixtures/UserSelectPage.ts b/browser_tests/fixtures/UserSelectPage.ts
index c0d4c90d3..62a961375 100644
--- a/browser_tests/fixtures/UserSelectPage.ts
+++ b/browser_tests/fixtures/UserSelectPage.ts
@@ -1,5 +1,4 @@
-import { test as base } from '@playwright/test'
-import { Page } from 'playwright'
+import { Page, test as base } from '@playwright/test'
 
 export class UserSelectPage {
   constructor(
diff --git a/browser_tests/fixtures/utils/taskHistory.ts b/browser_tests/fixtures/utils/taskHistory.ts
index 2c42c8492..01dfb1a4a 100644
--- a/browser_tests/fixtures/utils/taskHistory.ts
+++ b/browser_tests/fixtures/utils/taskHistory.ts
@@ -1,7 +1,7 @@
+import type { Request, Route } from '@playwright/test'
 import _ from 'es-toolkit/compat'
 import fs from 'fs'
 import path from 'path'
-import type { Request, Route } from 'playwright'
 import { v4 as uuidv4 } from 'uuid'
 
 import type {
diff --git a/knip.config.ts b/knip.config.ts
index 800831eb9..c691f3572 100644
--- a/knip.config.ts
+++ b/knip.config.ts
@@ -2,24 +2,31 @@ import type { KnipConfig } from 'knip'
 
 const config: KnipConfig = {
   entry: [
+    'build/**/*.ts',
+    'scripts/**/*.{js,ts}',
     'src/main.ts',
-    'vite.config.mts',
     'vite.electron.config.mts',
-    'vite.types.config.mts',
-    'eslint.config.js',
-    'tailwind.config.ts',
-    'postcss.config.js',
-    'playwright.config.ts',
-    'playwright.i18n.config.ts',
-    'vitest.config.ts',
-    'vitest.litegraph.config.ts',
-    'scripts/**/*.{js,ts}'
+    'vite.types.config.mts'
   ],
   project: [
+    'browser_tests/**/*.{js,ts}',
+    'build/**/*.{js,ts,vue}',
+    'scripts/**/*.{js,ts}',
     'src/**/*.{js,ts,vue}',
     'tests-ui/**/*.{js,ts,vue}',
-    'browser_tests/**/*.{js,ts}',
-    'scripts/**/*.{js,ts}'
+    '*.{js,ts,mts}'
+  ],
+  ignoreDependencies: [
+    '@primeuix/forms',
+    '@primeuix/styled',
+    '@primeuix/utils',
+    '@primevue/icons',
+    '@iconify/json',
+    'tailwindcss',
+    'tailwindcss-primeui', // Need to figure out why tailwind plugin isn't applying
+    // Dev
+    '@executeautomation/playwright-mcp-server',
+    '@trivago/prettier-plugin-sort-imports'
   ],
   ignore: [
     // Generated files
@@ -57,29 +64,21 @@ const config: KnipConfig = {
   ignoreExportsUsedInFile: true,
   // Vue-specific configuration
   vue: true,
+  tailwind: true,
   // Only check for unused files, disable all other rules
   // TODO: Gradually enable other rules - see https://github.com/Comfy-Org/ComfyUI_frontend/issues/4888
   rules: {
     binaries: 'off',
     classMembers: 'off',
-    dependencies: 'off',
-    devDependencies: 'off',
     duplicates: 'off',
     enumMembers: 'off',
     exports: 'off',
     nsExports: 'off',
     nsTypes: 'off',
-    types: 'off',
-    unlisted: 'off'
+    types: 'off'
   },
   // Include dependencies analysis
-  includeEntryExports: true,
-  // Workspace configuration for monorepo-like structure
-  workspaces: {
-    '.': {
-      entry: ['src/main.ts', 'playwright.i18n.config.ts']
-    }
-  }
+  includeEntryExports: true
 }
 
 export default config
